using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Xml.Linq;
using System.Diagnostics;
using System.IO;
using System.Xml;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Media;
using System.Windows.Media;
using System.Net;
using System.Globalization;



using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins;
using Styx.Pathing;

namespace katzerle
{
	class MountbugHelperPB: HBPlugin
	{	
		public static string name { get { return "MountbugHelperPB"; } }
		public override string Name { get { return name; } }
		public override string Author { get { return "katzerle"; } }
		private readonly static Version _version = new Version(0, 0);
		public override Version Version { get { return _version; } }
		public override string ButtonText { get { return "No Settings"; } }
		public override bool WantButton { get { return false; } }
		
		public static LocalPlayer Me = StyxWoW.Me;

		public override void OnButtonPress()
		{
		}
		
		public MountbugHelperPB()
        {
			Logging.Write(Colors.MediumPurple, "Mountbug Helper PB loaded");
        }

        static private void BotStopped(EventArgs args)
        {
        }
		
		public override void Initialize()
        {
		}
		
		public override void Pulse()
		{
			try
			{
				//if(InPetCombat())
				//{
					PluginContainer myPlugin = PluginManager.Plugins.Where(p=>p.Plugin.Name == Name).First();
					while(InPetCombat())
					{
						// pulse other plugins since we're in a loop
						List<PluginContainer> _pluginList = PluginManager.Plugins;
						foreach (PluginContainer _plugin in _pluginList)
						{
							if (_plugin.Enabled && _plugin.Plugin.Name != Name)
								_plugin.Plugin.Pulse();
								//Logging.Write(Colors.MediumPurple, "[MBH] Pulse Plugins {0}", _plugin.Plugin.Name);
						}
					}
				//}
			}
			catch (ThreadAbortException) { }
			catch (Exception e)
			{
				Logging.Write(Colors.Red, "MountbugHelperPB: Exception in Pulse:{0}", e);
			}
		}
		
		static public bool InPetCombat()
        {
            List<string> cnt = Lua.GetReturnValues("dummy,reason=C_PetBattles.IsTrapAvailable() return dummy,reason");

            if (cnt != null) { if (cnt[1] != "0") return true; }
            return false;
        }

	}
}